import pytest
from afs_api_worker.worker import ApiWorker

from afs_autotests.afs_base_objects.base_elements import AFSTestRun, AFSTestSuite, AFSTestProject, AFSTestCase


class BaseTest(object):
    """Базовый тест"""
    _api_worker = None
    active_testrun = AFSTestRun()
    active_testsuite = AFSTestSuite()
    active_project = AFSTestProject()
    active_testcase = AFSTestCase()

    @pytest.yield_fixture(autouse=True)
    def init_and_teardown(self, request, testrun_data, server, api_version):
        """Фикстура для init и tearDown теста"""
        self.init_test()
        yield  # everything after 'yield' is executed on tear-down
        self.teardown_test()

    def init_test(self):
        """Test init"""
        print('\nStart init test phase.')

    def teardown_test(self):
        """Test tearsown"""
        print('\nStart teardown test phase.')

    @property
    def api_worker(self) -> ApiWorker:
        """ Обьект для работы с Api"""
        return self._api_worker



